<?php

require_once('config.php');


class CurlUtil {
    public function __construct() {
        $this->api_url = API_URL;
    }

    public function set_api_url($api_url){
        $this->api_url = $api_url;
    }

    private function _request($method, $url_path, $params = NULL) {
        if (stripos($url_path, 'http://') === false && stripos($url_path, 'https://') === false) {
            $url = $this->api_url . $url_path;
        } else {
            $url = $url_path;
        }
        if ($method == 'GET' && $params) {
            $url = $url . '?' . http_build_query($params);
        }

        $ua = 'bdp-sdk-php, ' . VERSION;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_USERAGENT, $ua);
        curl_setopt($ch, CURLOPT_URL, $url);
        //curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);)
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);

        if ($method == 'POST') {
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
        }

        $output = curl_exec($ch);
        curl_close($ch);

        $res = json_decode($output, TRUE);
        if (!$res || intval($res['status']) != 0) {
            if (!$res) {
                $res = array("status"=>"-1", "errstr"=>"connection failed");
            }
            $format = "\nstatus: %s\nerror_str: %s\nrequest_id: %s";
            $error_msg = sprintf($format, $res['status'], $res['errstr'], $res['request_id']);
            throw new Exception($error_msg);
        }

        return $res['result'];
    }

    public function Get($url_path, $params) {
        return $this->_request('GET', $url_path, $params);
    }

    public function Post($url_path, $params, $body) {
        $url_path = $url_path . '?' . http_build_query($params);
        return $this->_request('POST', $url_path, json_encode($body));
    }
}
